
function CreateGrants()

	CreateBootstrapGrants();
	CreateFirstCellBlockGrant();
	CreateHealthGrant();
    CreateMaintenanceGrant();
    CreatePrisonerVisitationGrant();
    CreateBasicSecurityGrant();
    CreateEnhancedSecurityGrant();
    CreateAdvancedSecurityGrant();
    CreatePrisonerWorkforceGrant();
    CreateEducationReformGrant();
    CreateBailout();
    CreatePrisonLabourGrant();
    CreateFurnitureManufacturingGrant();
    
    CreateReduceStaffStressGrant();
    CreateNutritionResearchGrant();
    CreateDrugSearchGrant();
    CreateContrabandSupplyGrant();
    
    CreateShortTermInvestment();
    CreateLongTermInvestment();
    
    CreateCellBlockGrant( 50, -1 )
    CreateCellBlockGrant( 100, 50 )
    CreateCellBlockGrant( 200, 100 )
    CreateCellBlockGrant( 500, 200 )
   
    
end



function CreateBootstrapGrants()

	-- Basic Detention Centre
	
	Objective.CreateGrant			( "Grant_bootstraps", 20000, 10000 )
	
	Objective.CreateGrant			( "Grant_bootstraps_holdingcell", 0, 0 )	
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_bootstraps_wait", 0, 0 )	
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_bootstraps_shower", 0, 0 )	
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_bootstraps_yard", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )

	Objective.CreateGrant			( "Grant_bootstraps_kitchen", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_bootstraps_canteen", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )

	Objective.CreateGrant			( "Grant_bootstraps_guard", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )

	Objective.CreateGrant			( "Grant_bootstraps_chef", 0, 0 )
	Objective.SetParent				( "Grant_bootstraps" )
	Objective.RequireTimePassed     ( 0 )

	
	-- Basic Administrative set up
	
	Objective.CreateGrant			( "Grant_Administration", 5000, 5000 )
	
	Objective.CreateGrant			( "Grant_Administration_offices", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_Administration_Warden", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_Administration_Accountant_Research", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_Administration_Accountant", 0, 0 )
	Objective.SetParent				( "Grant_Administration" )
	Objective.RequireTimePassed     ( 0 )
	
end



function CreateFirstCellBlockGrant()

	Objective.CreateGrant			( "Grant_FirstCellBlock", 20000, 20000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_bootstraps", 0 )
	Objective.RequireTimePassed     ( 0 )

	Objective.CreateGrant			( "Grant_FirstCellBlock_Cells", 0, 0 )
	Objective.SetParent				( "Grant_FirstCellBlock" )	
	Objective.RequireTimePassed     ( 0 )
	
end

function CreateCellBlockGrant( requiredCells, preReq )
    grantName = "Grant_CellBlock" .. requiredCells
    preReqName = "Grant_CellBlock" .. preReq
    
    if preReq == -1 then
        preReqName = "Grant_FirstCellBlock"
    end
    
    Objective.CreateGrant			( grantName, 10000, 20000 )
    Objective.SetPreRequisite       ( "Completed", preReqName, 1 )
    Objective.HiddenWhileLocked     ()

	Objective.CreateGrant			( grantName .. "_Cells", 0, 0 )
	Objective.SetParent				( grantName )	
	Objective.RequireTimePassed     ( 0 )
end


function CreateHealthGrant()

	Objective.CreateGrant			( "Grant_Health", 10000, 10000 )
	
	Objective.CreateGrant			( "Grant_Health_Ward", 0, 0 )
	Objective.SetParent				( "Grant_Health" )
	Objective.RequireTimePassed     ( 0 )
	
	Objective.CreateGrant			( "Grant_Health_Doctors", 0, 0 )
	Objective.RequireTimePassed     ( 0 )
	Objective.SetParent				( "Grant_Health" )
	
	Objective.CreateGrant			( "Grant_Health_Psychologist", 0, 0 )
	Objective.RequireTimePassed     ( 0 )
	Objective.SetParent				( "Grant_Health" )
	
end

function CreateBailout()

    Objective.CreateGrant           ( "Grant_Bailout", 50000, 50000 )
    Objective.SetPreRequisite       ( "Cash", "AtMost", 500 )
    Objective.SetPreRequisite       ( "Cashflow", "AtMost", 0 )
    Objective.SetPreRequisite       ( "Debt", "AtLeast", 10000 )
    Objective.SetPreRequisite       ( "Prisoners", "AtLeast", 30 )
    Objective.HiddenWhileLocked     ()

    Objective.CreateGrant           ( "Grant_Bailout_Cashflow", 0, 0 )
    Objective.SetParent             ( "Grant_Bailout" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Bailout_Debt", 0, 0 )
    Objective.SetParent             ( "Grant_Bailout" )
	Objective.RequireTimePassed     ( 0 )

end

function CreateMaintenanceGrant()
    Objective.CreateGrant           ( "Grant_Maintenance", 10000, 5000 );
    Objective.SetPreRequisite       ( "Completed", "Grant_bootstraps", 0 )

    Objective.CreateGrant           ( "Grant_Maintenance_Research_Root", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Maintenance_Research_Cleaning", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Maintenance_Research_GroundsKeeping", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Maintenance_Foreman", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Maintenance_Janitor", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Maintenance_Gardener", 0, 0 )
    Objective.SetParent             ( "Grant_Maintenance" )
	Objective.RequireTimePassed     ( 0 )
end
    
function CreatePrisonerVisitationGrant()
    Objective.CreateGrant           ( "Grant_Visitation", 5000, 5000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_bootstraps", 0 )

    Objective.CreateGrant           ( "Grant_Visitation_Room", 0, 0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Visitation_Tables", 0 ,0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Visitation_CommonRoom", 0, 0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Visitation_PoolTable", 0 ,0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Visitation_TV", 0 ,0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_Visitation_Phones", 0 ,0 )
    Objective.SetParent             ( "Grant_Visitation" )
	Objective.RequireTimePassed     ( 0 ) 
    
end

function CreateBasicSecurityGrant()
    Objective.CreateGrant           ( "Grant_BasicSecurity", 10000, 10000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_bootstraps", 1 )
    
    Objective.CreateGrant           ( "Grant_BasicSecurity_Chief", 0, 0 )
    Objective.SetParent             ( "Grant_BasicSecurity" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_BasicSecurity_Guards", 0, 0 )
    Objective.SetParent             ( "Grant_BasicSecurity" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_BasicSecurity_Research", 0, 0 )
    Objective.SetParent             ( "Grant_BasicSecurity" )
	Objective.RequireTimePassed     ( 0 )   
    
    Objective.CreateGrant           ( "Grant_BasicSecurity_Patrols", 0, 0 )
    Objective.SetParent             ( "Grant_BasicSecurity" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateEnhancedSecurityGrant()
    Objective.CreateGrant           ( "Grant_EnhancedSecurity", 15000, 15000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_BasicSecurity", 1 )
    
    --Objective.CreateGrant           ( "Grant_EnhancedSecurity_Armoury", 0, 0 )
    --Objective.SetParent             ( "Grant_EnhancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_EnhancedSecurity_Guards", 0, 0 )
    --Objective.SetParent             ( "Grant_EnhancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_EnhancedSecurity_Kennel", 0, 0 )
    --Objective.SetParent             ( "Grant_EnhancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_EnhancedSecurity_Dogs", 0, 0 )
    --Objective.SetParent             ( "Grant_EnhancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_EnhancedSecurity_PatrolDogs", 0, 0 )
    Objective.SetParent             ( "Grant_EnhancedSecurity" )
    Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_EnhancedSecurity_PatrolArmed", 0, 0 )
    Objective.SetParent             ( "Grant_EnhancedSecurity" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateAdvancedSecurityGrant()
    Objective.CreateGrant           ( "Grant_AdvancedSecurity", 20000, 20000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_EnhancedSecurity", 1 )
    
    Objective.CreateGrant           ( "Grant_AdvancedSecurity_Guards", 0, 0 )
    Objective.SetParent             ( "Grant_AdvancedSecurity" )
	Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_AdvancedSecurity_ResearchCCTV", 0, 0 )
    --Objective.SetParent             ( "Grant_AdvancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_AdvancedSecurity_ResearchBodyArmour", 0, 0 )
    Objective.SetParent             ( "Grant_AdvancedSecurity" )
	Objective.RequireTimePassed     ( 0 ) 
    
    Objective.CreateGrant           ( "Grant_AdvancedSecurity_ResearchTazers", 0, 0 )
    Objective.SetParent             ( "Grant_AdvancedSecurity" )
	Objective.RequireTimePassed     ( 0 ) 
    
    --Objective.CreateGrant           ( "Grant_AdvancedSecurity_Office", 0, 0 )
    --Objective.SetParent             ( "Grant_AdvancedSecurity" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_AdvancedSecurity_CCTVMonitor", 0, 0 )
    Objective.SetParent             ( "Grant_AdvancedSecurity" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_AdvancedSecurity_CCTVCameras", 0, 0 )
    Objective.SetParent             ( "Grant_AdvancedSecurity" )
	Objective.RequireTimePassed     ( 0 )    
end

function CreatePrisonerWorkforceGrant()
    Objective.CreateGrant           ( "Grant_PrisonerWorkforce", 10000, 10000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_Maintenance", 1 )
    
    --Objective.CreateGrant           ( "Grant_PrisonerWorkforce_Research", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonerWorkforce" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_PrisonerWorkforce_Laundry", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonerWorkforce" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_PrisonerWorkforce_Cleaning", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonerWorkforce" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_PrisonerWorkforce_KitchenClass", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonerWorkforce" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_PrisonerWorkforce_LaundryAssigned", 0, 0 )
    Objective.SetParent             ( "Grant_PrisonerWorkforce" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_PrisonerWorkforce_KitchenAssigned", 0, 0 )
    Objective.SetParent             ( "Grant_PrisonerWorkforce" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_PrisonerWorkforce_CleaningAssigned", 0, 0 )
    Objective.SetParent             ( "Grant_PrisonerWorkforce" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateEducationReformGrant()
    Objective.CreateGrant           ( "Grant_EducationReformProgram", 15000, 40000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_Administration", 1 )

    Objective.CreateGrant           ( "Grant_EducationReformProgram_Research", 0, 0 )
    Objective.SetParent             ( "Grant_EducationReformProgram" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_EducationReformProgram_Classroom", 0, 0 )
    Objective.SetParent             ( "Grant_EducationReformProgram" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_EducationReformProgram_Desks", 0, 0 )
    Objective.SetParent             ( "Grant_EducationReformProgram" )
	Objective.RequireTimePassed     ( 0 ) 
    
    Objective.CreateGrant           ( "Grant_EducationReformProgram_FoundationEd", 0, 0 )
    Objective.SetParent             ( "Grant_EducationReformProgram" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_EducationReformProgram_GeneralEd", 0, 0 )
    Objective.SetParent             ( "Grant_EducationReformProgram" )
	Objective.RequireTimePassed     ( 0 )
end

function CreatePrisonLabourGrant()
    Objective.CreateGrant           ( "Grant_PrisonLabour", 20000, 10000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_PrisonerWorkforce", 1 )
    
    --Objective.CreateGrant           ( "Grant_PrisonLabour_Workshop", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonLabour" )
    --Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_PrisonLabour_Saw", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonLabour" )
    --Objective.RequireTimePassed     ( 0 ) 
    
    --Objective.CreateGrant           ( "Grant_PrisonLabour_Press", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonLabour" )
    --Objective.RequireTimePassed     ( 0 ) 
    
    --Objective.CreateGrant           ( "Grant_PrisonLabour_Reform", 0, 0 )
    --Objective.SetParent             ( "Grant_PrisonLabour" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_PrisonLabour_Plates", 0, 0 )
    Objective.SetParent             ( "Grant_PrisonLabour" )
	Objective.RequireTimePassed     ( 0 )    
end

function CreateFurnitureManufacturingGrant()
    Objective.CreateGrant           ( "Grant_FurnitureManufacturing", 10000, 10000 )
    Objective.SetPreRequisite       ( "Completed", "Grant_PrisonLabour", 1 )
    
    --Objective.CreateGrant           ( "Grant_FurnitureManufacturing_Forestry", 0, 0 )
    --Objective.SetParent             ( "Grant_FurnitureManufacturing" )
    --	Objective.RequireTimePassed     ( 0 )
    
    --Objective.CreateGrant           ( "Grant_FurnitureManufacturing_Table", 0, 0 )
    --Objective.SetParent             ( "Grant_FurnitureManufacturing" )
    --Objective.RequireTimePassed     ( 0 ) 
    
    --Objective.CreateGrant           ( "Grant_FurnitureManufacturing_Reform", 0, 0 )
    --Objective.SetParent             ( "Grant_FurnitureManufacturing" )
    --Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_FurnitureManufacturing_Bed", 0, 0 )
    Objective.SetParent             ( "Grant_FurnitureManufacturing" )
	Objective.RequireTimePassed     ( 0 )    
end

function CreateReduceStaffStressGrant()
    Objective.CreateGrant           ( "Grant_ReduceStaffStress", 0, 10000 )
    
    Objective.CreateGrant           ( "Grant_ReduceStaffStress_Staffroom", 0, 0 )
    Objective.SetParent             ( "Grant_ReduceStaffStress" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_ReduceStaffStress_FreeGuards", 0, 0 )
    Objective.SetParent             ( "Grant_ReduceStaffStress" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_ReduceStaffStress_RestedStaff", 0, 0 )
    Objective.SetParent             ( "Grant_ReduceStaffStress" )
	Objective.RequireTimePassed     ( 0 )
end

function  CreateShortTermInvestment()
    Objective.CreateGrant           ( "Grant_ShortTermInvestment", -5000, 16000 )
    Objective.SetPreRequisite       ( "Unlocked", "Finance", 0 )
    Objective.HiddenWhileLocked     ()
    
    Objective.CreateGrant           ( "Grant_ShortTermInvestment_Wait", 0, 0 )
    Objective.SetParent             ( "Grant_ShortTermInvestment" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateLongTermInvestment()
    Objective.CreateGrant           ( "Grant_LongTermInvestment", -5000, 16000 )
    Objective.SetPreRequisite       ( "Unlocked", "Finance", 0 )
    Objective.HiddenWhileLocked     ()
    
    Objective.CreateGrant           ( "Grant_LongTermInvestment_Wait", 0, 0 )
    Objective.SetParent             ( "Grant_LongTermInvestment" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateNutritionResearchGrant()
    Objective.CreateGrant           ( "Grant_NutritionResearch", 0, 15000 )
    
    Objective.CreateGrant           ( "Grant_NutritionResearch_Poor", 0, 0 )
    Objective.SetParent             ( "Grant_NutritionResearch" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_NutritionResearch_Good", 0, 0 )
    Objective.SetParent             ( "Grant_NutritionResearch" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateDrugSearchGrant()
    Objective.CreateGrant           ( "Grant_DrugSearch", 0, 15000 )
    
    Objective.CreateGrant           ( "Grant_DrugSearch_Find", 0, 0 )
    Objective.SetParent             ( "Grant_DrugSearch" )
	Objective.RequireTimePassed     ( 0 )
end

function CreateContrabandSupplyGrant()
    Objective.CreateGrant           ( "Grant_ContrabandSupply", 0, 20000 )
    
    Objective.CreateGrant           ( "Grant_ContrabandSupply_Tools", 0, 0 )
    Objective.SetParent             ( "Grant_ContrabandSupply" )
	Objective.RequireTimePassed     ( 0 )
    
    Objective.CreateGrant           ( "Grant_ContrabandSupply_Weapons", 0, 0 )
    Objective.SetParent             ( "Grant_ContrabandSupply" )
	Objective.RequireTimePassed     ( 0 )
end